summaryrefslogtreecommitdiffstats
path: root/misc/scripts
diff options
context:
space:
mode:
authorMarc Gilleron <marc.gilleron@gmail.com>2021-02-01 00:15:22 +0000
committerMarc Gilleron <marc.gilleron@gmail.com>2021-02-03 22:04:45 +0000
commit1f7f66d09e251fb5b3b2c1d6af43b738425f890f (patch)
treed2b6b77aceda8b41ddd16bf71b03321f03f74ee0 /misc/scripts
parent9598fd5c8ed10d10c2923e7bb117fafb37daf77e (diff)
downloadredot-cpp-1f7f66d09e251fb5b3b2c1d6af43b738425f890f.tar.gz
Re-added clang-format checks to the CI
Diffstat (limited to 'misc/scripts')
-rw-r--r--misc/scripts/clang_format.sh43
1 files changed, 43 insertions, 0 deletions
diff --git a/misc/scripts/clang_format.sh b/misc/scripts/clang_format.sh
new file mode 100644
index 0000000..0d1511e
--- /dev/null
+++ b/misc/scripts/clang_format.sh
@@ -0,0 +1,43 @@
+#!/usr/bin/env bash
+
+# This script runs clang-format on all relevant files in the repo.
+# This is the primary script responsible for fixing style violations.
+
+set -uo pipefail
+IFS=$'\n\t'
+
+CLANG_FORMAT_FILE_EXTS=(".c" ".h" ".cpp" ".hpp" ".cc" ".hh" ".cxx" ".m" ".mm" ".inc" ".java" ".glsl")
+
+# Loops through all text files tracked by Git.
+git grep -zIl '' |
+while IFS= read -rd '' f; do
+ # Exclude some files.
+ if [[ "$f" == "thirdparty"* ]]; then
+ continue
+ fi
+
+ for extension in ${CLANG_FORMAT_FILE_EXTS[@]}; do
+ if [[ "$f" == *"$extension" ]]; then
+ # Run clang-format.
+ clang-format -i "$f"
+ continue 2
+ fi
+ done
+done
+
+git diff > patch.patch
+
+# If no patch has been generated all is OK, clean up, and exit.
+if [ ! -s patch.patch ] ; then
+ printf "Files in this commit comply with the clang-format style rules.\n"
+ rm -f patch.patch
+ exit 0
+fi
+
+# A patch has been created, notify the user, clean up, and exit.
+printf "\n*** The following differences were found between the code "
+printf "and the formatting rules:\n\n"
+cat patch.patch
+printf "\n*** Aborting, please fix your commit(s) with 'git commit --amend' or 'git rebase -i <hash>'\n"
+rm -f patch.patch
+exit 1